<template>
  <div
    class="container-fluid w-100 h-100 bg-light overflow-auto"
    id="side-info"
  >
    <div class="row">
      <div class="container-fluid mt-4">
        <div class="row">
          <div class="col">
            <h3>Informations</h3>
          </div>
        </div>
        <hr class="dropdown-divider mb-4" />

        <div class="row">
          <div class="col">
            <h5>Informations Coureur</h5>
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Prénom:</p>
              <p class="d-inline">{{ athlete.first_name }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Nom:</p>
              <p class="d-inline">{{ athlete.last_name }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">
                Date de naissance (YYYY-DD-MM):
              </p>
              <p class="d-inline">{{ athlete.birthdate }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Email:</p>
              <p class="d-inline">{{ athlete.first_name }}</p></span
            >
          </div>
        </div>
        <div class="row text-start">
          <div class="col">
            <span class="d-inline"
              ><p class="d-inline fw-bolder me-2">Téléphone:</p>
              <p class="d-inline">{{ athlete.phone }}</p></span
            >
          </div>
        </div>
      </div>
      <div class="row text-start">
        <div class="col">
          <span class="d-inline"
            ><p class="d-inline fw-bolder">VA:</p>
            <span v-if="athlete.va.status === 0" class="badge ms-2 bg-secondary"
              >Abscent</span
            >
            <span
              v-else-if="athlete.va.status === 1"
              class="badge ms-2 bg-success"
              >Validé</span
            >
            <span
              v-else-if="athlete.va.status === 2"
              class="badge ms-2 bg-danger"
              >Rejeté</span
            >
            <span
              v-else-if="athlete.va.status === 3"
              class="badge ms-2 bg-warning"
              >A verifié</span
            >
          </span>
        </div>
      </div>

      <hr class="dropdown-divider my-4" />
      <div class="row">
        <div class="col">
          <h5>Validation VA</h5>
        </div>
      </div>

      <div class="row">
        <form class="text-start mb-5 fw-bold" @submit.prevent="checkVA">
          <div class="row m-2">
            <div class="col form-group">
              <label for="inputFirstName">Prénom: </label>
              <input
                v-model="firstName"
                type="text"
                class="form-control"
                id="inputFirstName"
                required
              />
            </div>
          </div>
          <div class="row m-2">
            <div class="col form-group">
              <label for="inputLastName">Nom: </label>
              <input
                v-model="lastName"
                type="text"
                class="form-control"
                id="inputLastName"
                required
              />
            </div>
          </div>
          <div class="row m-2">
            <div class="col form-group">
              <label for="inputVANumber">Numero VA: </label>
              <input
                v-model="vaNumber"
                type="text"
                class="form-control"
                id="inputVANumber"
                required
              />
            </div>
          </div>
          <div class="row m-2 mt-5">
            <div class="col form-group text-center">
              <button class="btn btn-primary" type="submit">Envoyer</button>
            </div>
          </div>
        </form>
        <div class="row m-2">
          <div class="col form-group text-center">
            <button
              class="btn btn-success m-2"
              type="button"
              @click="validateVA"
            >
              Valider manuellement
            </button>
            <button class="btn btn-danger" type="button" @click="rejectVA">
              Rejeter manuellement
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import axios from "axios";

export default defineComponent({
  props: {
    athleteId: Number,
  },
  data() {
    return {
      firstName: null as unknown,
      lastName: null as unknown,
      vaNumber: null as unknown,
      athlete: {
        id: null,
        first_name: null,
        last_name: null,
        birthdate: null,
        email: null,
        phone: null,
        team: {
          name: null,
          category: {
            label: null,
          },
        },
        va: {
          id: null,
          status: null,
        },
      },
    };
  },
  methods: {
    checkVA() {
      console.log("Checking VA...");
      axios
        .post("vas/" + this.athlete.va.id + "/check/", {
          first_name: this.firstName,
          last_name: this.lastName,
          card: this.vaNumber,
        })
        .then((response) => {
          console.log(response);
          this.reloadInfo();
        })
        .catch(() => {
          this.reloadInfo();
        });
    },
    reloadInfo() {
      axios
        .get("athletes/" + this.athleteId)
        .then((response) => (this.athlete = response.data));
    },
    validateVA() {
      console.log("Validating certificate...");
      axios
        .post("vas/" + this.athlete.va.id + "/validate/")
        .then((response) => {
          console.log(response);
          this.reloadInfo();
        });
    },
    rejectVA() {
      console.log("Reject certificate...");
      axios.post("vas/" + this.athlete.va.id + "/reject/").then((response) => {
        console.log(response);
        this.reloadInfo();
      });
    },
  },
  watch: {
    athleteId() {
      (document.getElementById("inputFirstName") as HTMLInputElement).value =
        "";
      (document.getElementById("inputLastName") as HTMLInputElement).value = "";
      (document.getElementById("inputVANumber") as HTMLInputElement).value = "";
      this.reloadInfo();
    },
  },
});
</script>
